package jesse.keeblarcraft.EventMgr;

import jesse.keeblarcraft.AttributeMgr.AttributeMgr;
import jesse.keeblarcraft.AttributeMgr.AttributeTree;
import jesse.keeblarcraft.ConfigMgr.ConfigManager;
import jesse.keeblarcraft.ConfigMgr.GeneralConfig;
import jesse.keeblarcraft.Utils.DirectionalVec;
import net.fabricmc.fabric.api.networking.v1.PacketSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.network.ServerPlayNetworkHandler;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.text.Text;

public class PlayerJoinListener {
    private static PlayerJoinListener static_inst;

    public static PlayerJoinListener GetInstance() {
        if (static_inst == null) {
            static_inst = new PlayerJoinListener();
        }
        return static_inst;
    }

    public void HandleServerJoinEvent(ServerPlayNetworkHandler handler, PacketSender sender, MinecraftServer server) {
        var player = handler.player;

        // Handle skill tree map instance
        if (AttributeMgr.activeTrees.containsKey(player.getUuidAsString()) == false) {
            AttributeMgr.activeTrees.put(player.getUuidAsString(), new AttributeTree(player.getUuidAsString()));
        }

        // Handle first time joining events (world spawn teleport, MOTD, etc)
        System.out.println("Running first time login stuff");
        IsFirstTimeLogin(player, server);
    }

    // this will be reworked in the future
    private void IsFirstTimeLogin(ServerPlayerEntity player, MinecraftServer server) {
        // Send the MOTD + Spawn in global spawn
        player.sendMessage(Text.of(GeneralConfig.GetInstance().GetMOTD()));
        if (GeneralConfig.GetInstance().IsNewPlayer(player.getUuidAsString())) {
            DirectionalVec coords = GeneralConfig.GetInstance().GetSpawnCoords();
            if (coords != null) {
                for (ServerWorld world : player.getServer().getWorlds()) {
                    if (world.getRegistryKey().toString().equals(coords.world.toString())) {
                        try {
                            player.teleport(world, coords.x, coords.y, coords.z, coords.yaw, coords.pitch);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    }
}
